# List attribute definitions

> Retrieve a paginated list of attribute definitions.
{/* generated:versioned-pages - edit _pm-authored, not this file */}

`GET /api/attribute_definitions`

Retrieves the collection of AttributeDefinition resources.

Returns a paginated collection of attribute definitions. Filter by `type`, `code` or `id[]`, search the translated `name` (case-insensitive partial match in the `Flowkiwi-Locale` locale), and sort by `order[createdAt]` or `order[updatedAt]`. This endpoint is only available in the `unstable` version.

## Headers

| Name              | Type     | Required | Description                                                                                                      |
| ----------------- | -------- | -------- | ---------------------------------------------------------------------------------------------------------------- |
| `Flowkiwi-Locale` | `string` | -        | Specifies the locale for properties that support localization. If not provided, the default locale will be used. |

## Query parameters

| Name               | Type       | Required | Description                                                                                                                                                                                                                                                                          |
| ------------------ | ---------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `page`             | `integer`  | -        | The collection page number                                                                                                                                                                                                                                                           |
| `itemsPerPage`     | `integer`  | -        | The number of items per page                                                                                                                                                                                                                                                         |
| `properties[]`     | `string[]` | -        | Allows you to reduce the response to contain only the properties you need. If your desired property is nested, you can address it using nested arrays. Example: properties[]={propertyName}&properties[]={anotherPropertyName}&properties[{nestedPropertyParent}][]={nestedProperty} |
| `id[]`             | `string[]` | -        | Only the items with one of these ids, each a UUID or the item IRI.                                                                                                                                                                                                                   |
| `type`             | `string`   | -        | AttributeDefinition type                                                                                                                                                                                                                                                             |
| `type[]`           | `string[]` | -        | AttributeDefinition type                                                                                                                                                                                                                                                             |
| `code`             | `string`   | -        | AttributeDefinition code                                                                                                                                                                                                                                                             |
| `code[]`           | `string[]` | -        | AttributeDefinition code                                                                                                                                                                                                                                                             |
| `name`             | `string`   | -        | Filter on the translated "name" field (case-insensitive partial match, uses the Flowkiwi-Locale header).                                                                                                                                                                             |
| `order[createdAt]` | `string`   | -        | AttributeDefinition order[createdAt]                                                                                                                                                                                                                                                 |
| `order[updatedAt]` | `string`   | -        | AttributeDefinition order[updatedAt]                                                                                                                                                                                                                                                 |

## Response

**200** - AttributeDefinition collection

| Property     | Type                    | Required | Description |
| ------------ | ----------------------- | -------- | ----------- |
| `search`     | `object`                | -        |             |
| `totalItems` | `integer`               | -        |             |
| `view`       | `object`                | -        |             |
| `member`     | `AttributeDefinition[]` | Yes      |             |

## Errors

**403** - Access denied. The caller is missing one or more permissions required for this operation.

| Property             | Type               | Required | Description                                                                                                            |
| -------------------- | ------------------ | -------- | ---------------------------------------------------------------------------------------------------------------------- |
| `@context`           | `string \| object` | -        |                                                                                                                        |
| `@id`                | `string`           | Yes      |                                                                                                                        |
| `@type`              | `string`           | Yes      |                                                                                                                        |
| `detail`             | `string`           | -        |                                                                                                                        |
| `missingPermissions` | `string[]`         | -        | Permissions that the caller is missing for this operation. Present only when the 403 is caused by a denied permission. |
| `status`             | `integer`          | -        |                                                                                                                        |
| `title`              | `string`           | -        |                                                                                                                        |
| `type`               | `string`           | -        |                                                                                                                        |

## Examples

### Example request

```bash
curl -X GET 'https://<tenant>.product-management.flowkiwi.net/api/attribute_definitions' \
  -H 'Authorization: Bearer {access_token}' \
  -H 'Flowkiwi-Api-Version: unstable' \
  -H 'Accept: application/ld+json'
```

### Example response

```json
{
  "@context": "/api/contexts/AttributeDefinition",
  "@id": "/api/attribute_definitions",
  "@type": "Collection",
  "member": [
    {
      "@context": "/api/contexts/AttributeDefinition",
      "@id": "/api/attribute_definitions/019afd11-4d5e-7f60-9b71-3c4d5e6f7081",
      "@type": "AttributeDefinition",
      "categories": [
        "/api/categories/019afd02-2b3c-7d4e-9f50-1a2b3c4d5e6f"
      ],
      "code": "care",
      "createdAt": "2026-01-15T09:30:00+00:00",
      "id": "019afd11-4d5e-7f60-9b71-3c4d5e6f7081",
      "multiple": false,
      "name": "Care",
      "type": "string",
      "updatedAt": "2026-02-03T14:45:12+00:00",
      "valuesCount": 4
    },
    {
      "@context": "/api/contexts/AttributeDefinition",
      "@id": "/api/attribute_definitions/019afd10-3c4d-7e5f-8a60-2b3c4d5e6f70",
      "@type": "AttributeDefinition",
      "categories": [
        "/api/categories/019afd02-2b3c-7d4e-9f50-1a2b3c4d5e6f"
      ],
      "code": "color",
      "createdAt": "2026-01-15T09:30:00+00:00",
      "id": "019afd10-3c4d-7e5f-8a60-2b3c4d5e6f70",
      "multiple": true,
      "name": "Color",
      "type": "list",
      "updatedAt": "2026-02-03T14:45:12+00:00",
      "valuesCount": 12
    }
  ],
  "totalItems": 2
}
```
